#include "huc.h"
/* 
GoldMage by Trilinear
trilinear@hotmail.com

feel free to borrow and learn from this,
just don't steal the whole thing and claim it as your own
I suck at commenting so email me if you have any questions, I can't get MIRC to work.

the artwork pcx's and fmps are copyright trilinear and won't be distributed. 
but I'll let you know that the tiles pcx has 4 palletes in it 
*/
  

#define TILE_VRAM    0x1000

#define VERSIONTEXT "GoldMage build 01.08.27 Public Source\0" 
#define NB_TILE  156

#define MAP_WIDTH  128
#define MAP_HEIGHT 128

#define BAT_WIDTH  32
#define BAT_HEIGHT 32

#define SCR_WIDTH  256
#define SCR_HEIGHT 224
#define SCR_TWIDTH  16
#define SCR_THEIGHT 14

#define CHAR_MID_X  128
#define CHAR_MID_Y  112

#define WALKVEL 1

#define BLOCK_UP 0x1
#define BLOCK_DOWN 0x2
#define BLOCK_LEFT 0x4
#define BLOCK_RGHT 0x8
#define BLOCK_ALL 0xF

#define WALK_UP 0x1
#define WALK_DOWN 0x2
#define WALK_LEFT 0x4
#define WALK_RGHT 0x8


#define         MODESTAND    0x0
#define         MODEWALK    0x1

#define         HEROFRONT1    0x4000
#define         HEROFRONT2    0x4200
#define         HEROFRONT3    0x4400
#define         HEROSIDE1    0x4600
#define         HEROSIDE2    0x4800
#define         HEROSIDE3    0x4A00
#define         HEROBACK1    0x4C00
#define         HEROBACK2    0x5000
#define         HEROBACK3    0x5200

#define         FGTILE00    0x6000


#define         FGTILE01    0x6040
#define         FGTILE02    0x6080
#define         FGTILE03    0x60C0
#define         FGTILE04    0x6100
#define         FGTILE05    0x6140
#define         FGTILE06    0x6180
#define         FGTILE07    0x61C0
#define         FGTILE08    0x6200
#define         FGTILE09    0x6240
#define         FGTILE10    0x6280
#define         FGTILE11    0x62C0
#define         FGTILE12    0x6300
#define         FGTILE13    0x6340
#define         FGTILE14    0x6380
#define         FGTILE15    0x63C0
#define         FGTILE16    0x6400
#define         FGTILE17    0x6440
#define         FGTILE18    0x6480
#define         FGTILE19    0x64C0
#define         FGTILE20    0x6500
#define         FGTILE21    0x6540
#define         FGTILE22    0x6580
#define         FGTILE23    0x65C0
#define         FGTILE24    0x6600
#define         FGTILE25    0x6640
#define         FGTILE26    0x6680
#define         FGTILE27    0x66C0
#define         FGTILE28    0x6700
#define         FGTILE29    0x6740
#define         FGTILE30    0x6780
#define         FGTILE31    0x67C0

#define HEROINDEX 15

#define PAL1  1
#define PAL2  2
#define PAL3  3
#define PAL4  4
#define PAL5  5
#define PAL6  6
#define PAL7  7
#define PANEL_PAL 10

#incbin(level1, "level1.fmp");

#inctile(tile_gfx, "magetiles.pcx", 13, 12)
#incpal(tile_pal1,  "magetiles.pcx", 15,1)
#incpal(tile_pal2,  "magetiles.pcx", 14,1)
#incpal(tile_pal3,  "magetiles.pcx", 13,1)
#incpal(tile_pal4,  "magetiles.pcx", 12,1)

#incspr(pherofront1, "magechar.pcx", 0, 0, 1, 2);
#incspr(pherofront2, "magechar.pcx", 16, 0, 1, 2);
#incspr(pherofront3, "magechar.pcx", 32, 0, 1, 2);
#incspr(pheroside1, "magechar.pcx", 48, 0, 1, 2);
#incspr(pheroside2, "magechar.pcx", 64, 0, 1, 2);
#incspr(pheroside3, "magechar.pcx", 80, 0, 1, 2);
#incspr(pheroback1, "magechar.pcx", 0, 32, 1, 2);
#incspr(pheroback2, "magechar.pcx", 16, 32, 1, 2);
#incspr(pheroback3, "magechar.pcx", 32, 32, 1, 2);
#incpal(herocolors, "magechar.pcx",15,1);


#incspr(pfgtile1, "magetilesfg.pcx", 0, 0, 1, 1);
#incspr(pfgtile2, "magetilesfg.pcx", 16, 0, 1, 1);
#incspr(pfgtile3, "magetilesfg.pcx", 32, 0, 1, 1);
#incspr(pfgtile4, "magetilesfg.pcx", 48, 0, 1, 1);
#incspr(pfgtile5, "magetilesfg.pcx", 64, 0, 1, 1);
#incspr(pfgtile6, "magetilesfg.pcx", 80, 0, 1, 1);
#incspr(pfgtile7, "magetilesfg.pcx", 0, 16, 1, 1);
#incspr(pfgtile8, "magetilesfg.pcx", 16, 16, 1, 1);
#incspr(pfgtile9, "magetilesfg.pcx", 32, 16, 1, 1);
#incspr(pfgtile10, "magetilesfg.pcx", 48, 16, 1, 1);
#incspr(pfgtile11, "magetilesfg.pcx", 64, 16, 1, 1);
#incspr(pfgtile12, "magetilesfg.pcx", 80, 16, 1, 1);
#incspr(pfgtile13, "magetilesfg.pcx", 0, 32, 1, 1);
#incspr(pfgtile14, "magetilesfg.pcx", 16, 32, 1, 1);
#incspr(pfgtile15, "magetilesfg.pcx", 32, 32, 1, 1);
#incspr(pfgtile16, "magetilesfg.pcx", 48, 32, 1, 1);
#incspr(pfgtile17, "magetilesfg.pcx", 64, 32, 1, 1);
#incspr(pfgtile18, "magetilesfg.pcx", 80, 32, 1, 1);
#incspr(pfgtile19, "magetilesfg.pcx", 96, 32, 1, 1);
#incspr(pfgtile20, "magetilesfg.pcx", 0, 48, 1, 1);
#incspr(pfgtile21, "magetilesfg.pcx", 16, 48, 1, 1);
#incspr(pfgtile22, "magetilesfg.pcx", 32, 48, 1, 1);
#incspr(pfgtile23, "magetilesfg.pcx", 48, 48, 1, 1);
#incspr(pfgtile24, "magetilesfg.pcx", 64, 48, 1, 1);
#incspr(pfgtile25, "magetilesfg.pcx", 80, 48, 1, 1);
#incspr(pfgtile26, "magetilesfg.pcx", 0, 64, 1, 1);
#incspr(pfgtile27, "magetilesfg.pcx", 16, 64, 1, 1);
#incspr(pfgtile28, "magetilesfg.pcx", 32, 64, 1, 1);
#incspr(pfgtile29, "magetilesfg.pcx", 48, 64, 1, 1);
#incspr(pfgtile30, "magetilesfg.pcx", 64, 64, 1, 1);
#incspr(pfgtile31, "magetilesfg.pcx", 80, 64, 1, 1);
#incspr(pfgtilenon, "magetilesfg.pcx", 96, 0, 1, 1);
#incpal(pfgtilepal, "magetilesfg.pcx", 15,1);

#incchr(tripic,"trilinearcard.pcx",32,28);
#incpal(tripal,"trilinearcard.pcx");
#incbat(tribat,"trilinearcard.pcx",TILE_VRAM,32,28);



const char tile_pal_ref[NB_TILE] = {
        PAL3<<4,PAL3<<4,PAL3<<4,PAL3<<4, PAL3<<4,PAL3<<4,PAL3<<4,PAL4<<4, PAL4<<4,PAL4<<4,PAL4<<4,PAL4<<4, PAL4<<4, 
        PAL3<<4,PAL3<<4,PAL3<<4,PAL3<<4, PAL3<<4,PAL3<<4,PAL3<<4,PAL4<<4, PAL4<<4,PAL4<<4,PAL4<<4,PAL4<<4, PAL4<<4, 
        PAL3<<4,PAL3<<4,PAL3<<4,PAL3<<4, PAL3<<4,PAL3<<4,PAL3<<4,PAL4<<4, PAL4<<4,PAL4<<4,PAL4<<4,PAL4<<4, PAL4<<4, 
        PAL3<<4,PAL3<<4,PAL3<<4,PAL3<<4, PAL1<<4,PAL1<<4,PAL1<<4,PAL4<<4, PAL4<<4,PAL4<<4,PAL4<<4,PAL4<<4, PAL4<<4, 

        PAL3<<4,PAL3<<4,PAL3<<4,PAL3<<4, PAL2<<4,PAL2<<4,PAL2<<4,PAL4<<4, PAL4<<4,PAL4<<4,PAL4<<4,PAL4<<4, PAL4<<4, 
        PAL3<<4,PAL3<<4,PAL3<<4,PAL3<<4, PAL2<<4,PAL2<<4,PAL2<<4,PAL4<<4, PAL4<<4,PAL4<<4,PAL4<<4,PAL4<<4, PAL4<<4, 
        PAL3<<4,PAL3<<4,PAL3<<4,PAL3<<4, PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL2<<4, 
        PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL2<<4,PAL1<<4,PAL1<<4,PAL2<<4, PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL2<<4, 

        PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL2<<4,PAL1<<4,PAL1<<4,PAL2<<4, PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL2<<4, 
        PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL1<<4,PAL1<<4,PAL1<<4,PAL2<<4, PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL2<<4, 
        PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL1<<4,PAL1<<4,PAL1<<4,PAL1<<4, PAL1<<4,PAL1<<4,PAL1<<4,PAL1<<4, PAL1<<4, 
        PAL2<<4,PAL2<<4,PAL2<<4,PAL2<<4, PAL1<<4,PAL1<<4,PAL1<<4,PAL1<<4, PAL1<<4,PAL1<<4,PAL1<<4,PAL1<<4, PAL1<<4 

};


const char tile_walkability[NB_TILE] = {
	    0x0,0xF,0xF,0xF, 0x0,0x0,0x0,0xF, 0xF,0xF,0xF,0xF, 0xF,
	    0xF,0xF,0xF,0xF, 0x0,0x0,0x0,0xF, 0xF,0xF,0xF,0xF, 0xF,
	    0x0,0x0,0x0,0x0, 0x0,0x0,0x0,0x0, 0x0,0xF,0xF,0xF, 0xF,
	    0x0,0x0,0x0,0x0, 0x0,0x0,0x0,0x0, 0x0,0xF,0xF,0xF, 0xF,

	    0xF,0xF,0xF,0xF, 0xF,0xF,0xF,0xF, 0xF,0xF,0xF,0xF, 0xF,
	    0xF,0xF,0xF,0xF, 0xF,0xF,0xF,0xF, 0xF,0x0,0x0,0x0, 0x0,
	    0xF,0xF,0xF,0xF, 0xF,0xF,0xF,0x0, 0x0,0x0,0x0,0x0, 0x0,
	    0xF,0xF,0xF,0xF, 0xF,0x0,0x0,0x0, 0x0,0x0,0x0,0x0, 0x0,

	    0xF,0xF,0xF,0xF, 0xF,0x0,0x0,0xF, 0xF,0xF,0xF,0xF, 0xF,
	    0xF,0xF,0xF,0x0, 0x0,0xF,0x0,0xF, 0xF,0xF,0xF,0xF, 0xF,
	    0xF,0x0,0x0,0x0, 0x0,0xF,0xF,0x0, 0x0,0x0,0xF,0xF, 0xF,
	    0xF,0x0,0xF,0xF, 0x0,0xF,0xF,0xF, 0x0,0xF,0x0,0xF, 0xF

};

const int FG_tilemap[NB_TILE] = {
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00, 
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE05, FGTILE06,FGTILE00,FGTILE00,FGTILE00, FGTILE00,
	    FGTILE01,FGTILE02,FGTILE03,FGTILE04, FGTILE00,FGTILE00,FGTILE00,FGTILE11, FGTILE12,FGTILE00,FGTILE00,FGTILE00, FGTILE00, 
	    FGTILE07,FGTILE08,FGTILE09,FGTILE10, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00, 

	    FGTILE13,FGTILE14,FGTILE15,FGTILE16, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE20, FGTILE21,FGTILE22,FGTILE23,FGTILE24, FGTILE25, 
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE26, FGTILE27,FGTILE28,FGTILE29,FGTILE30, FGTILE31, 

	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00, 
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00, 
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE17, FGTILE18,FGTILE19,FGTILE00,FGTILE00, FGTILE00, 
	    FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00,FGTILE00,FGTILE00,FGTILE00, FGTILE00 
};


runintro() {
	int cnt;
	init_satb();
	put_string(VERSIONTEXT, 1, 1);
	vsync(60);
	load_background(tripic, tripal, tribat, 32, 28);
	vsync(200);
	cls();
}


loadhero() 
{
	load_vram(HEROFRONT1, pherofront1, 0x40);
	load_vram(HEROFRONT1+0x40+0x40, pherofront1+0x40, 0x40);
	load_vram(HEROFRONT2, pherofront2, 0x40);
	load_vram(HEROFRONT2+0x40+0x40, pherofront2+0x40, 0x40);
	load_vram(HEROFRONT3, pherofront3, 0x40);
	load_vram(HEROFRONT3+0x40+0x40, pherofront3+0x40, 0x40);
	load_vram(HEROSIDE1, pheroside1, 0x40);
	load_vram(HEROSIDE1+0x40+0x40, pheroside1+0x40, 0x40);
	load_vram(HEROSIDE2, pheroside2, 0x40);
	load_vram(HEROSIDE2+0x40+0x40, pheroside2+0x40, 0x40);
	load_vram(HEROSIDE3, pheroside3, 0x40);
	load_vram(HEROSIDE3+0x40+0x40, pheroside3+0x40, 0x40);
	load_vram(HEROBACK1, pheroback1, 0x40);
	load_vram(HEROBACK1+0x40+0x40, pheroback1+0x40, 0x40);
	load_vram(HEROBACK2, pheroback2, 0x40);
	load_vram(HEROBACK2+0x40+0x40, pheroback2+0x40, 0x40);
	load_vram(HEROBACK3, pheroback3, 0x40);
	load_vram(HEROBACK3+0x40+0x40, pheroback3+0x40, 0x40);
}

loadfg() 
{
	load_vram(FGTILE00, pfgtilenon, 0x40);

	load_vram(FGTILE01, pfgtile1, 0x40);
	load_vram(FGTILE02, pfgtile2, 0x40);
	load_vram(FGTILE03, pfgtile3, 0x40);
	load_vram(FGTILE04, pfgtile4, 0x40);
	load_vram(FGTILE05, pfgtile5, 0x40);
	load_vram(FGTILE06, pfgtile6, 0x40);
	load_vram(FGTILE07, pfgtile7, 0x40);
	load_vram(FGTILE08, pfgtile8, 0x40);
	load_vram(FGTILE09, pfgtile9, 0x40);
	load_vram(FGTILE10, pfgtile10, 0x40);
	load_vram(FGTILE11, pfgtile11, 0x40);
	load_vram(FGTILE12, pfgtile12, 0x40);
	load_vram(FGTILE13, pfgtile13, 0x40);
	load_vram(FGTILE14, pfgtile14, 0x40);
	load_vram(FGTILE15, pfgtile15, 0x40);
	load_vram(FGTILE16, pfgtile16, 0x40);
	load_vram(FGTILE17, pfgtile17, 0x40);
	load_vram(FGTILE18, pfgtile18, 0x40);
	load_vram(FGTILE19, pfgtile19, 0x40);
	load_vram(FGTILE20, pfgtile20, 0x40);
	load_vram(FGTILE21, pfgtile21, 0x40);
	load_vram(FGTILE22, pfgtile22, 0x40);
	load_vram(FGTILE23, pfgtile23, 0x40);
	load_vram(FGTILE24, pfgtile24, 0x40);
	load_vram(FGTILE25, pfgtile25, 0x40);
	load_vram(FGTILE26, pfgtile26, 0x40);
	load_vram(FGTILE27, pfgtile27, 0x40);
	load_vram(FGTILE28, pfgtile28, 0x40);
	load_vram(FGTILE29, pfgtile29, 0x40);
	load_vram(FGTILE30, pfgtile30, 0x40);
	load_vram(FGTILE31, pfgtile31, 0x40);
	
}

int charx,chary,tilex,tiley,oldtilex,oldtiley;
int tempx,tempx2,tempy,tempy2;

setupfg() {
	spr_set(1);
	spr_x(((charx>>4))<<4);
	spr_y(((chary>>4))<<4);
	spr_pattern(FGTILE00);
	spr_ctrl(SIZE_MAS|FLIP_X_MASK, SZ_16x16|NO_FLIP_X);
	spr_pal(1);
	spr_pri(1);

	spr_set(2);
	spr_x(((charx>>4)+1)<<4);
	spr_y(((chary>>4))<<4);
	spr_pattern(FGTILE00);
	spr_ctrl(SIZE_MAS|FLIP_X_MASK, SZ_16x16|NO_FLIP_X);
	spr_pal(1);
	spr_pri(1);

	spr_set(3);
	spr_x(((charx>>4))<<4);
	spr_y(((chary>>4)+1)<<4);
	spr_pattern(FGTILE00);
	spr_ctrl(SIZE_MAS|FLIP_X_MASK, SZ_16x16|NO_FLIP_X);
	spr_pal(1);
	spr_pri(1);

	spr_set(4);
	spr_x(((charx>>4)+1)<<4);
	spr_y(((chary>>4)+1)<<4);
	spr_pattern(FGTILE00);
	spr_ctrl(SIZE_MAS|FLIP_X_MASK, SZ_16x16|NO_FLIP_X);
	spr_pal(1);
	spr_pri(1);

	spr_set(5);
	spr_x(((charx>>4))<<4);
	spr_y(((chary>>4)+2)<<4);
	spr_pattern(FGTILE00);
	spr_ctrl(SIZE_MAS|FLIP_X_MASK, SZ_16x16|NO_FLIP_X);
	spr_pal(1);
	spr_pri(1);

	spr_set(6);
	spr_x(((charx>>4)+1)<<4);
	spr_y(((chary>>4)+2)<<4);
	spr_pattern(FGTILE00);
	spr_ctrl(SIZE_MAS|FLIP_X_MASK, SZ_16x16|NO_FLIP_X);
	spr_pal(1);
	spr_pri(1);

}

updatefg() {
	spr_set(1);
	tempx=(((charx+tilex)>>4));
	tempy=(((chary+tiley)>>4));
	tempx2=(charx&0xFFF0)-(tilex&0xF);
	tempy2=(chary&0xFFF0)-(tiley&0xF);

	spr_x(tempx2);
	spr_y(tempy2);
	spr_pal(1);
	spr_pattern(FG_tilemap[get_tile(tempx,tempy)]); 

	spr_set(2);
	spr_x(tempx2+16);
	spr_y((chary&0xFFF0)-(tiley&0xF));
	spr_pal(1);
	spr_pattern(FG_tilemap[get_tile(tempx+1,tempy)]);


	spr_set(3);
	spr_x(tempx2);
	spr_y(tempy2+16);
	spr_pal(1);
	spr_pattern(FG_tilemap[get_tile(tempx,tempy+1)]);


	spr_set(4);
	spr_x(tempx2+16);
	spr_y(tempy2+16);
	spr_pal(1);
	spr_pattern(FG_tilemap[get_tile(tempx+1,tempy+1)]);


	spr_set(5);
	spr_x(tempx2);
	spr_y(tempy2+32);
	spr_pal(1);
	spr_pattern(FG_tilemap[get_tile(tempx,tempy+2)]);

	spr_set(6);
	spr_x(tempx2+16);
	spr_y(tempy2+32);
	spr_pal(1);
	spr_pattern(FG_tilemap[get_tile(tempx+1,tempy+2)]);

	/*get_tile(tempx,tempy)*/
}

#define LOADLEFT 1
#define LOADRIGHT 2
#define LOADUP 4
#define LOADDOWN 8

move(dx, dy)
int dx;
int dy;
{
	char updatetile;
	
	updatetile=0;
	if(dx) {
		charx+=dx;
		if (charx>CHAR_MID_X) {
			if (tilex>= ((MAP_WIDTH<<4)-SCR_WIDTH) ) {
				tilex=(MAP_WIDTH<<4)-SCR_WIDTH;
				dx=0;
			}else{
				charx=CHAR_MID_X;
				tilex+=dx;
				updatetile=1;
			}
		}else if (charx<CHAR_MID_X) {
			if (tilex<=0) {
				tilex=0;
				dx=0;
			}else{
				charx=CHAR_MID_X;
				tilex+=dx;
				updatetile=1;
			}
		}
		if (charx<0) charx=0;
		if (charx> (SCR_WIDTH-16)) charx=SCR_WIDTH-16;

	}
	if (dy) {
		chary+=dy;
		if (chary>CHAR_MID_Y) {
			if (tiley>= ((MAP_HEIGHT<<4)-SCR_HEIGHT) ) {
				tiley=(MAP_HEIGHT<<4)-SCR_HEIGHT;
				dy=0;
			}else{
				chary=CHAR_MID_Y;
				tiley+=dy;
				updatetile=1;
			}
		}else if (chary<CHAR_MID_Y) {
			if (tiley<=0) {
				tiley=0;
				dy=0;
			}else{
				chary=CHAR_MID_Y;
				tiley+=dy;
				updatetile=1;
			}
		}
		if (chary<0) chary=0;
		if (chary> (SCR_HEIGHT-32)) chary=SCR_HEIGHT-32;
	}
	
	if (updatetile) {
		movetile(dx,dy);	
		oldtilex=tilex;
		oldtiley=tiley;
	}





}

movetile(dx, dy)
int dx;
int dy;
{
	int  x, y;
	char h,update;

	update=0;

	if(dx){
		if ((tilex|0xF) != (oldtilex|0xF)) {
			if (dx<0) {
				load_map(
					((tilex>>4))&0x1F, 
					0, 
					((tilex>>4))%MAP_WIDTH, 
					(((tiley+0xFF)>>9)<<5),
					1,16
					);
				load_map(
					((tilex>>4))&0x1F, 
					16, 
					((tilex>>4))%MAP_WIDTH, 
					(((tiley>>9)<<5)+16)%MAP_HEIGHT,
					1,16
					);
			}else{
				load_map(
					((tilex>>4)+16)&0x1F, 
					0, 
					((tilex>>4)+16)%MAP_WIDTH, 
					(((tiley+0xFF)>>9)<<5),
					1,16
					);
				load_map(
					((tilex>>4)+16)&0x1F, 
					16, 
					((tilex>>4)+16)%MAP_WIDTH, 
					(((tiley>>9)<<5)+16)%MAP_HEIGHT,
					1,16
					);
			}
		}
	}

	if (dy) {

		if ((tiley|0xF) != (oldtiley|0xF)) {
			if (dy<0) {
				load_map(
					0,
					((tiley>>4))&0x1F, 
					(((tilex+0xFF)>>9)<<5)%MAP_WIDTH,
					((tiley>>4))%MAP_HEIGHT, 
					16,1
					);
				load_map(
					16,
					((tiley>>4))&0x1F, 
					(((tilex>>9)<<5)+16)%MAP_WIDTH,
					((tiley>>4))%MAP_HEIGHT, 
					16,1
					);

			}else{
				load_map(
					0,
					((tiley>>4)+16)&0x1F, 
					(((tilex+0xFF)>>9)<<5)%MAP_WIDTH,
					((tiley>>4)+16)%MAP_HEIGHT, 
					16,1
					);
				load_map(
					16,
					((tiley>>4)+16)&0x1F, 
					(((tilex>>9)<<5)+16)%MAP_WIDTH,
					((tiley>>4)+16)%MAP_HEIGHT, 
					16,1
					);
			}
		}
	}

}



initgame() {
	tilex=0;tiley=0;
	oldtilex=0;oldtiley=0;
 	charx = CHAR_MID_X;
	chary = CHAR_MID_Y;
	
	set_screen_size(SCR_SIZE_64x64);
	set_map_data(level1, MAP_WIDTH, MAP_HEIGHT);
	set_tile_data(tile_gfx, NB_TILE, tile_pal_ref);
    load_tile(TILE_VRAM);
	load_palette(PAL1, tile_pal1, 1);
	load_palette(PAL2, tile_pal2, 1);
	load_palette(PAL3, tile_pal3, 1);
	load_palette(PAL4, tile_pal4, 1);

	load_map(0, 0, tilex, tiley, 17, 17);

	loadhero();
	loadfg();

	set_sprpal(0, herocolors);
	set_sprpal(1, pfgtilepal);

    scroll(0, 0,   0,   0, 223, 0xC0);
  
	init_satb();
	spr_set(HEROINDEX);
	spr_x(charx);
	spr_y(chary);
	spr_pattern(HEROFRONT1);
	spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x32|NO_FLIP_X);
	spr_pal(0);
	spr_pri(1);

	setupfg();


}

rungame() 
{
	int cnt, dir,CharMode;
	int idx,tempx1,tempy,tempx2;
    dir=1;     

	cnt=0;

	initgame();

	for (;;) {/*main game loop*/
		spr_set(0);
		CharMode=MODESTAND;	
		if (cnt > 40) {/* we need to swap direction */
			cnt=0;
		} else{
             cnt++;
		}

		spr_set(HEROINDEX);
		if (joy(0) & JOY_DOWN) {
			move(0,WALKVEL);
			CharMode=MODEWALK;
			dir=WALK_DOWN;
			spr_ctrl(FLIP_MAS, NO_FLIP_X);
			tempx1=(((charx+tilex)+1)>>4);
			tempx2=(((charx+tilex)+15)>>4);
			tempy=(((chary+tiley)+31)>>4);
			if ((tile_walkability[get_tile(tempx1,tempy)]&BLOCK_RGHT)!=0x0 ||
				   (tile_walkability[get_tile(tempx2,tempy)]&BLOCK_RGHT)!=0x0) {
				move(0,-WALKVEL);
			}

		}else if (joy(0) & JOY_UP) {
			move(0,-WALKVEL);
			CharMode=MODEWALK;
			dir=WALK_UP;
			spr_ctrl(FLIP_MAS, NO_FLIP_X);
			tempx1=(((charx+tilex)+1)>>4);
			tempx2=(((charx+tilex)+15)>>4);
			tempy=(((chary+tiley)+31)>>4);
			if ((tile_walkability[get_tile(tempx1,tempy)]&BLOCK_RGHT)!=0x0 ||
				   (tile_walkability[get_tile(tempx2,tempy)]&BLOCK_RGHT)!=0x0) { 
				move(0,WALKVEL);
			}		
		}
		if (joy(0) & JOY_LEFT) {
			move(-WALKVEL,0);
			CharMode=MODEWALK; 
			dir=WALK_LEFT;
			spr_ctrl(FLIP_MAS, FLIP_X);
			tempx1=(((charx+tilex)+1)>>4);
			tempx2=(((charx+tilex)+15)>>4);
			tempy=(((chary+tiley)+31)>>4);
			if ((tile_walkability[get_tile(tempx1,tempy)]&BLOCK_RGHT)!=0x0 ||
				   (tile_walkability[get_tile(tempx2,tempy)]&BLOCK_RGHT)!=0x0) { 
				move(WALKVEL,0);
			}		
		}else if (joy(0) & JOY_RGHT) {
			move(WALKVEL,0);
			CharMode=MODEWALK; 
			dir=WALK_RGHT;
			spr_ctrl(FLIP_MAS, NO_FLIP_X);
			tempx1=(((charx+tilex)+1)>>4);
			tempx2=(((charx+tilex)+15)>>4);
			tempy=(((chary+tiley)+31)>>4);
			if ((tile_walkability[get_tile(tempx1,tempy)]&BLOCK_RGHT)!=0x0 ||
				   (tile_walkability[get_tile(tempx2,tempy)]&BLOCK_RGHT)!=0x0) { 
				move(-WALKVEL,0);
			}		
		}

		scroll(0, tilex&0x1FF, tiley&0x1FF,   0, 223, 0xC0);

		

		spr_x(charx);
		spr_y(chary);

		if (CharMode==MODESTAND) {
			cnt=0;
		}

		if (dir==WALK_DOWN) {
			if (cnt<10) {
				spr_pattern(HEROFRONT1);
			}else{
				if (cnt<20) {
					spr_pattern(HEROFRONT2);
				}else{
					if (cnt<30) {
						spr_pattern(HEROFRONT1);
					}else{
						spr_pattern(HEROFRONT3);
					}
				}
			}
		}else if (dir==WALK_UP) {
			if (cnt<10) {
				spr_pattern(HEROBACK1);
			}else{
				if (cnt<20) {
					spr_pattern(HEROBACK2);
				}else{
					if (cnt<30) {
						spr_pattern(HEROBACK1);
					}else{
						spr_pattern(HEROBACK3);
					}
				}
			}
		}else if (dir==WALK_LEFT) {
			if (cnt<10) {
				spr_pattern(HEROSIDE1);
			}else{
				if (cnt<20) {
					spr_pattern(HEROSIDE2);
				}else{
					if (cnt<30) {
						spr_pattern(HEROSIDE1);
					}else{
						spr_pattern(HEROSIDE3);
					}
				}
			}
		}else	if (dir==WALK_RGHT) {
			if (cnt<10) {
				spr_pattern(HEROSIDE1);
			}else{
				if (cnt<20) {
					spr_pattern(HEROSIDE2);
				}else{
					if (cnt<30) {
						spr_pattern(HEROSIDE1);
					}else{
						spr_pattern(HEROSIDE3);
					}
				}
			}
		}

		
		updatefg(); 

        satb_update();

		vsync();


	}
}

main()
{

	/*  clear display */
	disp_off();
	cls();
  	disp_on();

	runintro();

	/*  clear display */
	disp_off();
	cls();
  	disp_on();

	rungame();


}

